  


<!DOCTYPE html>
<html>
  <head prefix="og: http://ogp.me/ns# fb: http://ogp.me/ns/fb# githubog: http://ogp.me/ns/fb/githubog#">
    <meta charset='utf-8'>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <title>flot/excanvas.min.js at master · flot/flot · GitHub</title>
    <link rel="search" type="application/opensearchdescription+xml" href="/opensearch.xml" title="GitHub" />
    <link rel="fluid-icon" href="https://github.com/fluidicon.png" title="GitHub" />
    <link rel="apple-touch-icon-precomposed" sizes="57x57" href="apple-touch-icon-114.png" />
    <link rel="apple-touch-icon-precomposed" sizes="114x114" href="apple-touch-icon-114.png" />
    <link rel="apple-touch-icon-precomposed" sizes="72x72" href="apple-touch-icon-144.png" />
    <link rel="apple-touch-icon-precomposed" sizes="144x144" href="apple-touch-icon-144.png" />
    <meta name="msapplication-TileImage" content="/windows-tile.png">
    <meta name="msapplication-TileColor" content="#ffffff">

    
    
    <link rel="icon" type="image/x-icon" href="/favicon.ico" />

    <meta content="authenticity_token" name="csrf-param" />
<meta content="7OdF1iTPO/F+ZFVfwskLT9VCU1ZLBtCnAaXY5O28O8o=" name="csrf-token" />

    <link href="https://a248.e.akamai.net/assets.github.com/assets/github-1e699dcaed667c20178cde536f3662dde2ff7a0e.css" media="screen" rel="stylesheet" type="text/css" />
    <link href="https://a248.e.akamai.net/assets.github.com/assets/github2-678b50bf7cba9691eead17e12530134d01b45f04.css" media="screen" rel="stylesheet" type="text/css" />
    


    <script src="https://a248.e.akamai.net/assets.github.com/assets/frameworks-c9ece3c1d530c8b5201cab80ec5efc53bf244a05.js" type="text/javascript"></script>
    <script src="https://a248.e.akamai.net/assets.github.com/assets/github-dc5b8095529da6d9db0d3f7251dfe76535c35735.js" type="text/javascript"></script>
    

      <link rel='permalink' href='/flot/flot/blob/1262aa39181dfd66bf5e6366a09ded2859489d28/excanvas.min.js'>
    <meta property="og:title" content="flot"/>
    <meta property="og:type" content="githubog:gitrepository"/>
    <meta property="og:url" content="https://github.com/flot/flot"/>
    <meta property="og:image" content="https://a248.e.akamai.net/assets.github.com/images/gravatars/gravatar-user-420.png?1345673562"/>
    <meta property="og:site_name" content="GitHub"/>
    <meta property="og:description" content="Attractive Javascript charts for jQuery. Contribute to flot development by creating an account on GitHub."/>

    <meta name="description" content="Attractive Javascript charts for jQuery. Contribute to flot development by creating an account on GitHub." />

  <link href="https://github.com/flot/flot/commits/master.atom" rel="alternate" title="Recent Commits to flot:master" type="application/atom+xml" />

  </head>


  <body class="logged_out page-blob windows vis-public env-production ">
    <div id="wrapper">

    
    

    

      <div id="header" class="true clearfix">
        <div class="container clearfix">
          <a class="site-logo " href="https://github.com/">
            <img alt="GitHub" class="github-logo-4x" height="30" src="https://a248.e.akamai.net/assets.github.com/images/modules/header/logov7@4x.png?1338956357" />
            <img alt="GitHub" class="github-logo-4x-hover" height="30" src="https://a248.e.akamai.net/assets.github.com/images/modules/header/logov7@4x-hover.png?1338956357" />
          </a>


                  <ul class="top-nav logged_out">
        <li class="pricing"><a href="https://github.com/signup">Sign up for free</a></li>
        <li class="explore"><a href="https://github.com/explore">Explore GitHub</a></li>
      <li class="features"><a href="https://github.com/features">Features</a></li>
        <li class="blog"><a href="https://github.com/blog">Blog</a></li>
      <li class="login"><a href="https://github.com/login?return_to=%2Fflot%2Fflot%2Fblob%2Fmaster%2Fexcanvas.min.js">Sign in</a></li>
    </ul>



          
        </div>
      </div>

      

      


            <div class="site hfeed" itemscope itemtype="http://schema.org/WebPage">
      <div class="hentry">
        
        <div class="pagehead repohead instapaper_ignore readability-menu">
          <div class="container">
            <div class="title-actions-bar">
              


                  <ul class="pagehead-actions">


          <li>
            <span class="star-button"><a href="/login?return_to=%2Fflot%2Fflot" class="minibutton js-toggler-target entice tooltipped leftwards" title="You must be signed in to use this feature" rel="nofollow"><span class="mini-icon mini-icon-star"></span>Star</a><a class="social-count js-social-count" href="/flot/flot/stargazers">1,246</a></span>
          </li>
          <li>
            <a href="/login?return_to=%2Fflot%2Fflot" class="minibutton js-toggler-target fork-button entice tooltipped leftwards"  title="You must be signed in to fork a repository" rel="nofollow"><span class="mini-icon mini-icon-fork"></span>Fork</a><a href="/flot/flot/network" class="social-count">263</a>
          </li>
    </ul>

              <h1 itemscope itemtype="http://data-vocabulary.org/Breadcrumb" class="entry-title public">
                <span class="repo-label"><span>public</span></span>
                <span class="mega-icon mega-icon-public-repo"></span>
                <span class="author vcard">
                  <a href="/flot" class="url fn" itemprop="url" rel="author">
                  <span itemprop="title">flot</span>
                  </a></span> /
                <strong><a href="/flot/flot" class="js-current-repository">flot</a></strong>
              </h1>
            </div>

            

  <ul class="tabs">
    <li><a href="/flot/flot" class="selected" highlight="repo_sourcerepo_downloadsrepo_commitsrepo_tagsrepo_branches">Code</a></li>
    <li><a href="/flot/flot/network" highlight="repo_network">Network</a></li>
    <li><a href="/flot/flot/pulls" highlight="repo_pulls">Pull Requests <span class='counter'>46</span></a></li>

      <li><a href="/flot/flot/issues" highlight="repo_issues">Issues <span class='counter'>254</span></a></li>

      <li><a href="/flot/flot/wiki" highlight="repo_wiki">Wiki</a></li>


    <li><a href="/flot/flot/graphs" highlight="repo_graphsrepo_contributors">Graphs</a></li>


  </ul>
  
<div class="tabnav">

  <span class="tabnav-right">
    <ul class="tabnav-tabs">
      <li><a href="/flot/flot/tags" class="tabnav-tab" highlight="repo_tags">Tags <span class="counter ">1</span></a></li>
      <li><a href="/flot/flot/downloads" class="tabnav-tab" highlight="repo_downloads">Downloads <span class="counter blank">0</span></a></li>
    </ul>
    
  </span>

  <div class="tabnav-widget scope">


    <div class="context-menu-container js-menu-container js-context-menu">
      <a href="#"
         class="minibutton bigger switcher js-menu-target js-commitish-button btn-branch repo-tree"
         data-hotkey="w"
         data-ref="master">
         <span><em class="mini-icon mini-icon-branch"></em><i>branch:</i> master</span>
      </a>

      <div class="context-pane commitish-context js-menu-content">
        <a href="javascript:;" class="close js-menu-close"><span class="mini-icon mini-icon-remove-close"></span></a>
        <div class="context-title">Switch branches/tags</div>
        <div class="context-body pane-selector commitish-selector js-navigation-container">
          <div class="filterbar">
            <input type="text" id="context-commitish-filter-field" class="js-navigation-enable js-filterable-field" placeholder="Filter branches/tags">
            <ul class="tabs">
              <li><a href="#" data-filter="branches" class="selected">Branches</a></li>
                <li><a href="#" data-filter="tags">Tags</a></li>
            </ul>
          </div>

          <div class="js-filter-tab js-filter-branches" data-filterable-for="context-commitish-filter-field" data-filterable-type=substring>
              <div class="commitish-item branch-commitish selector-item js-navigation-item js-navigation-target selected">
                <span class="mini-icon mini-icon-confirm"></span>
                <h4>
                    <a href="/flot/flot/blob/master/excanvas.min.js" class="js-navigation-open" data-name="master" rel="nofollow">master</a>
                </h4>
              </div>
          </div>

            <div class="js-filter-tab js-filter-tags " style="display:none" data-filterable-for="context-commitish-filter-field" data-filterable-type=substring>
                <div class="commitish-item tag-commitish selector-item js-navigation-item js-navigation-target ">
                  <span class="mini-icon mini-icon-confirm"></span>
                  <h4>
                      <a href="/flot/flot/blob/v0.7/excanvas.min.js" class="js-navigation-open" data-name="v0.7" rel="nofollow">v0.7</a>
                  </h4>
                </div>
            </div>

          <div class="no-results">Nothing to show</div>
        </div>
      </div><!-- /.commitish-context-context -->
    </div>
  </div> <!-- /.scope -->

  <ul class="tabnav-tabs">
    <li><a href="/flot/flot" class="selected tabnav-tab" highlight="repo_source">Files</a></li>
    <li><a href="/flot/flot/commits/master" class="tabnav-tab" highlight="repo_commits">Commits</a></li>
    <li><a href="/flot/flot/branches" class="tabnav-tab" highlight="repo_branches" rel="nofollow">Branches <span class="counter ">1</span></a></li>
  </ul>

</div>

  
  
  


            
          </div>
        </div><!-- /.repohead -->

        <div id="js-repo-pjax-container" class="container context-loader-container" data-pjax-container>
          


<!-- blob contrib key: blob_contributors:v21:21ed614ed728f369918420585ad2fc8b -->
<!-- blob contrib frag key: views10/v8/blob_contributors:v21:21ed614ed728f369918420585ad2fc8b -->

<div id="slider">


    <p title="This is a placeholder element" class="js-history-link-replace hidden"></p>
    <div class="breadcrumb" data-path="excanvas.min.js/">
      <b itemscope="" itemtype="http://data-vocabulary.org/Breadcrumb"><a href="/flot/flot" class="js-slider-breadcrumb" itemscope="url"><span itemprop="title">flot</span></a></b> / <strong class="final-path">excanvas.min.js</strong> <span class="js-clippy mini-icon mini-icon-clippy " data-clipboard-text="excanvas.min.js" data-copied-hint="copied!" data-copy-hint="copy to clipboard"></span>
    </div>

    <a href="/flot/flot/find/master" class="js-slide-to" data-hotkey="t" style="display:none">Show File Finder</a>

      
  <div class="commit file-history-tease" data-path="excanvas.min.js/">
    <img class="main-avatar" height="24" src="https://secure.gravatar.com/avatar/eae106cfe94b9d34a9ef1a41077b88e9?s=140&amp;d=https://a248.e.akamai.net/assets.github.com%2Fimages%2Fgravatars%2Fgravatar-user-420.png" width="24" />
    <span class="author"><a href="/OleLaursen">OleLaursen</a></span>
    <time class="js-relative-date" datetime="2011-05-13T04:13:50-07:00" title="2011-05-13 04:13:50">May 13, 2011</time>
    <div class="commit-title">
        <a href="/flot/flot/commit/f6cebd3f130fd9c10387a2ba41dbda5a7476451c" class="message">Update excanvas and remove previous eventholder work-around to fix ho…</a>
    </div>

    <div class="participation">
      <p class="quickstat"><a href="#blob_contributors_box" rel="facebox"><strong>1</strong> contributor</a></p>
      
    </div>
    <div id="blob_contributors_box" style="display:none">
      <h2>Users on GitHub who have contributed to this file</h2>
      <ul class="facebox-user-list">
        <li>
          <img height="24" src="https://secure.gravatar.com/avatar/eae106cfe94b9d34a9ef1a41077b88e9?s=140&amp;d=https://a248.e.akamai.net/assets.github.com%2Fimages%2Fgravatars%2Fgravatar-user-420.png" width="24" />
          <a href="/OleLaursen">OleLaursen</a>
        </li>
      </ul>
    </div>
  </div>


    <div class="frames">
      <div class="frame frame-center" data-path="excanvas.min.js/" data-permalink-url="/flot/flot/blob/1262aa39181dfd66bf5e6366a09ded2859489d28/excanvas.min.js" data-title="flot/excanvas.min.js at master · flot/flot · GitHub" data-type="blob">

        <div id="files" class="bubble">
          <div class="file">
            <div class="meta">
              <div class="info">
                <span class="icon"><b class="mini-icon mini-icon-text-file"></b></span>
                <span class="mode" title="File Mode">file</span>
                  <span>1 lines (1 sloc)</span>
                <span>19.314 kb</span>
              </div>
              <ul class="button-group actions">
                  <li>
                    <a class="grouped-button file-edit-link minibutton bigger lighter" href="/flot/flot/edit/master/excanvas.min.js" data-method="post" rel="nofollow" data-hotkey="e">Edit</a>
                  </li>
                <li>
                  <a href="/flot/flot/raw/master/excanvas.min.js" class="minibutton grouped-button bigger lighter" id="raw-url">Raw</a>
                </li>
                  <li>
                    <a href="/flot/flot/blame/master/excanvas.min.js" class="minibutton grouped-button bigger lighter">Blame</a>
                  </li>
                <li>
                  <a href="/flot/flot/commits/master/excanvas.min.js" class="minibutton grouped-button bigger lighter" rel="nofollow">History</a>
                </li>
              </ul>
            </div>
                <div class="data type-javascript">
      <table cellpadding="0" cellspacing="0" class="lines">
        <tr>
          <td>
            <pre class="line_numbers"><span id="L1" rel="#L1">1</span>
</pre>
          </td>
          <td width="100%">
                <div class="highlight"><pre><div class='line' id='LC1'>if(!document.createElement(&quot;canvas&quot;).getContext){(function(){var ab=Math;var n=ab.round;var l=ab.sin;var A=ab.cos;var H=ab.abs;var N=ab.sqrt;var d=10;var f=d/2;var z=+navigator.userAgent.match(/MSIE ([\d.]+)?/)[1];function y(){return this.context_||(this.context_=new D(this))}var t=Array.prototype.slice;function g(j,m,p){var i=t.call(arguments,2);return function(){return j.apply(m,i.concat(t.call(arguments)))}}function af(i){return String(i).replace(/&amp;/g,&quot;&amp;amp;&quot;).replace(/&quot;/g,&quot;&amp;quot;&quot;)}function Y(m,j,i){if(!m.namespaces[j]){m.namespaces.add(j,i,&quot;#default#VML&quot;)}}function R(j){Y(j,&quot;g_vml_&quot;,&quot;urn:schemas-microsoft-com:vml&quot;);Y(j,&quot;g_o_&quot;,&quot;urn:schemas-microsoft-com:office:office&quot;);if(!j.styleSheets.ex_canvas_){var i=j.createStyleSheet();i.owningElement.id=&quot;ex_canvas_&quot;;i.cssText=&quot;canvas{display:inline-block;overflow:hidden;text-align:left;width:300px;height:150px}&quot;}}R(document);var e={init:function(i){var j=i||document;j.createElement(&quot;canvas&quot;);j.attachEvent(&quot;onreadystatechange&quot;,g(this.init_,this,j))},init_:function(p){var m=p.getElementsByTagName(&quot;canvas&quot;);for(var j=0;j&lt;m.length;j++){this.initElement(m[j])}},initElement:function(j){if(!j.getContext){j.getContext=y;R(j.ownerDocument);j.innerHTML=&quot;&quot;;j.attachEvent(&quot;onpropertychange&quot;,x);j.attachEvent(&quot;onresize&quot;,W);var i=j.attributes;if(i.width&amp;&amp;i.width.specified){j.style.width=i.width.nodeValue+&quot;px&quot;}else{j.width=j.clientWidth}if(i.height&amp;&amp;i.height.specified){j.style.height=i.height.nodeValue+&quot;px&quot;}else{j.height=j.clientHeight}}return j}};function x(j){var i=j.srcElement;switch(j.propertyName){case&quot;width&quot;:i.getContext().clearRect();i.style.width=i.attributes.width.nodeValue+&quot;px&quot;;i.firstChild.style.width=i.clientWidth+&quot;px&quot;;break;case&quot;height&quot;:i.getContext().clearRect();i.style.height=i.attributes.height.nodeValue+&quot;px&quot;;i.firstChild.style.height=i.clientHeight+&quot;px&quot;;break}}function W(j){var i=j.srcElement;if(i.firstChild){i.firstChild.style.width=i.clientWidth+&quot;px&quot;;i.firstChild.style.height=i.clientHeight+&quot;px&quot;}}e.init();var k=[];for(var ae=0;ae&lt;16;ae++){for(var ad=0;ad&lt;16;ad++){k[ae*16+ad]=ae.toString(16)+ad.toString(16)}}function B(){return[[1,0,0],[0,1,0],[0,0,1]]}function J(p,m){var j=B();for(var i=0;i&lt;3;i++){for(var ah=0;ah&lt;3;ah++){var Z=0;for(var ag=0;ag&lt;3;ag++){Z+=p[i][ag]*m[ag][ah]}j[i][ah]=Z}}return j}function v(j,i){i.fillStyle=j.fillStyle;i.lineCap=j.lineCap;i.lineJoin=j.lineJoin;i.lineWidth=j.lineWidth;i.miterLimit=j.miterLimit;i.shadowBlur=j.shadowBlur;i.shadowColor=j.shadowColor;i.shadowOffsetX=j.shadowOffsetX;i.shadowOffsetY=j.shadowOffsetY;i.strokeStyle=j.strokeStyle;i.globalAlpha=j.globalAlpha;i.font=j.font;i.textAlign=j.textAlign;i.textBaseline=j.textBaseline;i.arcScaleX_=j.arcScaleX_;i.arcScaleY_=j.arcScaleY_;i.lineScale_=j.lineScale_}var b={aliceblue:&quot;#F0F8FF&quot;,antiquewhite:&quot;#FAEBD7&quot;,aquamarine:&quot;#7FFFD4&quot;,azure:&quot;#F0FFFF&quot;,beige:&quot;#F5F5DC&quot;,bisque:&quot;#FFE4C4&quot;,black:&quot;#000000&quot;,blanchedalmond:&quot;#FFEBCD&quot;,blueviolet:&quot;#8A2BE2&quot;,brown:&quot;#A52A2A&quot;,burlywood:&quot;#DEB887&quot;,cadetblue:&quot;#5F9EA0&quot;,chartreuse:&quot;#7FFF00&quot;,chocolate:&quot;#D2691E&quot;,coral:&quot;#FF7F50&quot;,cornflowerblue:&quot;#6495ED&quot;,cornsilk:&quot;#FFF8DC&quot;,crimson:&quot;#DC143C&quot;,cyan:&quot;#00FFFF&quot;,darkblue:&quot;#00008B&quot;,darkcyan:&quot;#008B8B&quot;,darkgoldenrod:&quot;#B8860B&quot;,darkgray:&quot;#A9A9A9&quot;,darkgreen:&quot;#006400&quot;,darkgrey:&quot;#A9A9A9&quot;,darkkhaki:&quot;#BDB76B&quot;,darkmagenta:&quot;#8B008B&quot;,darkolivegreen:&quot;#556B2F&quot;,darkorange:&quot;#FF8C00&quot;,darkorchid:&quot;#9932CC&quot;,darkred:&quot;#8B0000&quot;,darksalmon:&quot;#E9967A&quot;,darkseagreen:&quot;#8FBC8F&quot;,darkslateblue:&quot;#483D8B&quot;,darkslategray:&quot;#2F4F4F&quot;,darkslategrey:&quot;#2F4F4F&quot;,darkturquoise:&quot;#00CED1&quot;,darkviolet:&quot;#9400D3&quot;,deeppink:&quot;#FF1493&quot;,deepskyblue:&quot;#00BFFF&quot;,dimgray:&quot;#696969&quot;,dimgrey:&quot;#696969&quot;,dodgerblue:&quot;#1E90FF&quot;,firebrick:&quot;#B22222&quot;,floralwhite:&quot;#FFFAF0&quot;,forestgreen:&quot;#228B22&quot;,gainsboro:&quot;#DCDCDC&quot;,ghostwhite:&quot;#F8F8FF&quot;,gold:&quot;#FFD700&quot;,goldenrod:&quot;#DAA520&quot;,grey:&quot;#808080&quot;,greenyellow:&quot;#ADFF2F&quot;,honeydew:&quot;#F0FFF0&quot;,hotpink:&quot;#FF69B4&quot;,indianred:&quot;#CD5C5C&quot;,indigo:&quot;#4B0082&quot;,ivory:&quot;#FFFFF0&quot;,khaki:&quot;#F0E68C&quot;,lavender:&quot;#E6E6FA&quot;,lavenderblush:&quot;#FFF0F5&quot;,lawngreen:&quot;#7CFC00&quot;,lemonchiffon:&quot;#FFFACD&quot;,lightblue:&quot;#ADD8E6&quot;,lightcoral:&quot;#F08080&quot;,lightcyan:&quot;#E0FFFF&quot;,lightgoldenrodyellow:&quot;#FAFAD2&quot;,lightgreen:&quot;#90EE90&quot;,lightgrey:&quot;#D3D3D3&quot;,lightpink:&quot;#FFB6C1&quot;,lightsalmon:&quot;#FFA07A&quot;,lightseagreen:&quot;#20B2AA&quot;,lightskyblue:&quot;#87CEFA&quot;,lightslategray:&quot;#778899&quot;,lightslategrey:&quot;#778899&quot;,lightsteelblue:&quot;#B0C4DE&quot;,lightyellow:&quot;#FFFFE0&quot;,limegreen:&quot;#32CD32&quot;,linen:&quot;#FAF0E6&quot;,magenta:&quot;#FF00FF&quot;,mediumaquamarine:&quot;#66CDAA&quot;,mediumblue:&quot;#0000CD&quot;,mediumorchid:&quot;#BA55D3&quot;,mediumpurple:&quot;#9370DB&quot;,mediumseagreen:&quot;#3CB371&quot;,mediumslateblue:&quot;#7B68EE&quot;,mediumspringgreen:&quot;#00FA9A&quot;,mediumturquoise:&quot;#48D1CC&quot;,mediumvioletred:&quot;#C71585&quot;,midnightblue:&quot;#191970&quot;,mintcream:&quot;#F5FFFA&quot;,mistyrose:&quot;#FFE4E1&quot;,moccasin:&quot;#FFE4B5&quot;,navajowhite:&quot;#FFDEAD&quot;,oldlace:&quot;#FDF5E6&quot;,olivedrab:&quot;#6B8E23&quot;,orange:&quot;#FFA500&quot;,orangered:&quot;#FF4500&quot;,orchid:&quot;#DA70D6&quot;,palegoldenrod:&quot;#EEE8AA&quot;,palegreen:&quot;#98FB98&quot;,paleturquoise:&quot;#AFEEEE&quot;,palevioletred:&quot;#DB7093&quot;,papayawhip:&quot;#FFEFD5&quot;,peachpuff:&quot;#FFDAB9&quot;,peru:&quot;#CD853F&quot;,pink:&quot;#FFC0CB&quot;,plum:&quot;#DDA0DD&quot;,powderblue:&quot;#B0E0E6&quot;,rosybrown:&quot;#BC8F8F&quot;,royalblue:&quot;#4169E1&quot;,saddlebrown:&quot;#8B4513&quot;,salmon:&quot;#FA8072&quot;,sandybrown:&quot;#F4A460&quot;,seagreen:&quot;#2E8B57&quot;,seashell:&quot;#FFF5EE&quot;,sienna:&quot;#A0522D&quot;,skyblue:&quot;#87CEEB&quot;,slateblue:&quot;#6A5ACD&quot;,slategray:&quot;#708090&quot;,slategrey:&quot;#708090&quot;,snow:&quot;#FFFAFA&quot;,springgreen:&quot;#00FF7F&quot;,steelblue:&quot;#4682B4&quot;,tan:&quot;#D2B48C&quot;,thistle:&quot;#D8BFD8&quot;,tomato:&quot;#FF6347&quot;,turquoise:&quot;#40E0D0&quot;,violet:&quot;#EE82EE&quot;,wheat:&quot;#F5DEB3&quot;,whitesmoke:&quot;#F5F5F5&quot;,yellowgreen:&quot;#9ACD32&quot;};function M(j){var p=j.indexOf(&quot;(&quot;,3);var i=j.indexOf(&quot;)&quot;,p+1);var m=j.substring(p+1,i).split(&quot;,&quot;);if(m.length!=4||j.charAt(3)!=&quot;a&quot;){m[3]=1}return m}function c(i){return parseFloat(i)/100}function r(j,m,i){return Math.min(i,Math.max(m,j))}function I(ag){var i,ai,aj,ah,ak,Z;ah=parseFloat(ag[0])/360%360;if(ah&lt;0){ah++}ak=r(c(ag[1]),0,1);Z=r(c(ag[2]),0,1);if(ak==0){i=ai=aj=Z}else{var j=Z&lt;0.5?Z*(1+ak):Z+ak-Z*ak;var m=2*Z-j;i=a(m,j,ah+1/3);ai=a(m,j,ah);aj=a(m,j,ah-1/3)}return&quot;#&quot;+k[Math.floor(i*255)]+k[Math.floor(ai*255)]+k[Math.floor(aj*255)]}function a(j,i,m){if(m&lt;0){m++}if(m&gt;1){m--}if(6*m&lt;1){return j+(i-j)*6*m}else{if(2*m&lt;1){return i}else{if(3*m&lt;2){return j+(i-j)*(2/3-m)*6}else{return j}}}}var C={};function F(j){if(j in C){return C[j]}var ag,Z=1;j=String(j);if(j.charAt(0)==&quot;#&quot;){ag=j}else{if(/^rgb/.test(j)){var p=M(j);var ag=&quot;#&quot;,ah;for(var m=0;m&lt;3;m++){if(p[m].indexOf(&quot;%&quot;)!=-1){ah=Math.floor(c(p[m])*255)}else{ah=+p[m]}ag+=k[r(ah,0,255)]}Z=+p[3]}else{if(/^hsl/.test(j)){var p=M(j);ag=I(p);Z=p[3]}else{ag=b[j]||j}}}return C[j]={color:ag,alpha:Z}}var o={style:&quot;normal&quot;,variant:&quot;normal&quot;,weight:&quot;normal&quot;,size:10,family:&quot;sans-serif&quot;};var L={};function E(i){if(L[i]){return L[i]}var p=document.createElement(&quot;div&quot;);var m=p.style;try{m.font=i}catch(j){}return L[i]={style:m.fontStyle||o.style,variant:m.fontVariant||o.variant,weight:m.fontWeight||o.weight,size:m.fontSize||o.size,family:m.fontFamily||o.family}}function u(m,j){var i={};for(var ah in m){i[ah]=m[ah]}var ag=parseFloat(j.currentStyle.fontSize),Z=parseFloat(m.size);if(typeof m.size==&quot;number&quot;){i.size=m.size}else{if(m.size.indexOf(&quot;px&quot;)!=-1){i.size=Z}else{if(m.size.indexOf(&quot;em&quot;)!=-1){i.size=ag*Z}else{if(m.size.indexOf(&quot;%&quot;)!=-1){i.size=(ag/100)*Z}else{if(m.size.indexOf(&quot;pt&quot;)!=-1){i.size=Z/0.75}else{i.size=ag}}}}}i.size*=0.981;return i}function ac(i){return i.style+&quot; &quot;+i.variant+&quot; &quot;+i.weight+&quot; &quot;+i.size+&quot;px &quot;+i.family}var s={butt:&quot;flat&quot;,round:&quot;round&quot;};function S(i){return s[i]||&quot;square&quot;}function D(i){this.m_=B();this.mStack_=[];this.aStack_=[];this.currentPath_=[];this.strokeStyle=&quot;#000&quot;;this.fillStyle=&quot;#000&quot;;this.lineWidth=1;this.lineJoin=&quot;miter&quot;;this.lineCap=&quot;butt&quot;;this.miterLimit=d*1;this.globalAlpha=1;this.font=&quot;10px sans-serif&quot;;this.textAlign=&quot;left&quot;;this.textBaseline=&quot;alphabetic&quot;;this.canvas=i;var m=&quot;width:&quot;+i.clientWidth+&quot;px;height:&quot;+i.clientHeight+&quot;px;overflow:hidden;position:absolute&quot;;var j=i.ownerDocument.createElement(&quot;div&quot;);j.style.cssText=m;i.appendChild(j);var p=j.cloneNode(false);p.style.backgroundColor=&quot;red&quot;;p.style.filter=&quot;alpha(opacity=0)&quot;;i.appendChild(p);this.element_=j;this.arcScaleX_=1;this.arcScaleY_=1;this.lineScale_=1}var q=D.prototype;q.clearRect=function(){if(this.textMeasureEl_){this.textMeasureEl_.removeNode(true);this.textMeasureEl_=null}this.element_.innerHTML=&quot;&quot;};q.beginPath=function(){this.currentPath_=[]};q.moveTo=function(j,i){var m=V(this,j,i);this.currentPath_.push({type:&quot;moveTo&quot;,x:m.x,y:m.y});this.currentX_=m.x;this.currentY_=m.y};q.lineTo=function(j,i){var m=V(this,j,i);this.currentPath_.push({type:&quot;lineTo&quot;,x:m.x,y:m.y});this.currentX_=m.x;this.currentY_=m.y};q.bezierCurveTo=function(m,j,ak,aj,ai,ag){var i=V(this,ai,ag);var ah=V(this,m,j);var Z=V(this,ak,aj);K(this,ah,Z,i)};function K(i,Z,m,j){i.currentPath_.push({type:&quot;bezierCurveTo&quot;,cp1x:Z.x,cp1y:Z.y,cp2x:m.x,cp2y:m.y,x:j.x,y:j.y});i.currentX_=j.x;i.currentY_=j.y}q.quadraticCurveTo=function(ai,m,j,i){var ah=V(this,ai,m);var ag=V(this,j,i);var aj={x:this.currentX_+2/3*(ah.x-this.currentX_),y:this.currentY_+2/3*(ah.y-this.currentY_)};var Z={x:aj.x+(ag.x-this.currentX_)/3,y:aj.y+(ag.y-this.currentY_)/3};K(this,aj,Z,ag)};q.arc=function(al,aj,ak,ag,j,m){ak*=d;var ap=m?&quot;at&quot;:&quot;wa&quot;;var am=al+A(ag)*ak-f;var ao=aj+l(ag)*ak-f;var i=al+A(j)*ak-f;var an=aj+l(j)*ak-f;if(am==i&amp;&amp;!m){am+=0.125}var Z=V(this,al,aj);var ai=V(this,am,ao);var ah=V(this,i,an);this.currentPath_.push({type:ap,x:Z.x,y:Z.y,radius:ak,xStart:ai.x,yStart:ai.y,xEnd:ah.x,yEnd:ah.y})};q.rect=function(m,j,i,p){this.moveTo(m,j);this.lineTo(m+i,j);this.lineTo(m+i,j+p);this.lineTo(m,j+p);this.closePath()};q.strokeRect=function(m,j,i,p){var Z=this.currentPath_;this.beginPath();this.moveTo(m,j);this.lineTo(m+i,j);this.lineTo(m+i,j+p);this.lineTo(m,j+p);this.closePath();this.stroke();this.currentPath_=Z};q.fillRect=function(m,j,i,p){var Z=this.currentPath_;this.beginPath();this.moveTo(m,j);this.lineTo(m+i,j);this.lineTo(m+i,j+p);this.lineTo(m,j+p);this.closePath();this.fill();this.currentPath_=Z};q.createLinearGradient=function(j,p,i,m){var Z=new U(&quot;gradient&quot;);Z.x0_=j;Z.y0_=p;Z.x1_=i;Z.y1_=m;return Z};q.createRadialGradient=function(p,ag,m,j,Z,i){var ah=new U(&quot;gradientradial&quot;);ah.x0_=p;ah.y0_=ag;ah.r0_=m;ah.x1_=j;ah.y1_=Z;ah.r1_=i;return ah};q.drawImage=function(aq,m){var aj,ah,al,ay,ao,am,at,aA;var ak=aq.runtimeStyle.width;var ap=aq.runtimeStyle.height;aq.runtimeStyle.width=&quot;auto&quot;;aq.runtimeStyle.height=&quot;auto&quot;;var ai=aq.width;var aw=aq.height;aq.runtimeStyle.width=ak;aq.runtimeStyle.height=ap;if(arguments.length==3){aj=arguments[1];ah=arguments[2];ao=am=0;at=al=ai;aA=ay=aw}else{if(arguments.length==5){aj=arguments[1];ah=arguments[2];al=arguments[3];ay=arguments[4];ao=am=0;at=ai;aA=aw}else{if(arguments.length==9){ao=arguments[1];am=arguments[2];at=arguments[3];aA=arguments[4];aj=arguments[5];ah=arguments[6];al=arguments[7];ay=arguments[8]}else{throw Error(&quot;Invalid number of arguments&quot;)}}}var az=V(this,aj,ah);var p=at/2;var j=aA/2;var ax=[];var i=10;var ag=10;ax.push(&quot; &lt;g_vml_:group&quot;,' coordsize=&quot;',d*i,&quot;,&quot;,d*ag,'&quot;',' coordorigin=&quot;0,0&quot;',' style=&quot;width:',i,&quot;px;height:&quot;,ag,&quot;px;position:absolute;&quot;);if(this.m_[0][0]!=1||this.m_[0][1]||this.m_[1][1]!=1||this.m_[1][0]){var Z=[];Z.push(&quot;M11=&quot;,this.m_[0][0],&quot;,&quot;,&quot;M12=&quot;,this.m_[1][0],&quot;,&quot;,&quot;M21=&quot;,this.m_[0][1],&quot;,&quot;,&quot;M22=&quot;,this.m_[1][1],&quot;,&quot;,&quot;Dx=&quot;,n(az.x/d),&quot;,&quot;,&quot;Dy=&quot;,n(az.y/d),&quot;&quot;);var av=az;var au=V(this,aj+al,ah);var ar=V(this,aj,ah+ay);var an=V(this,aj+al,ah+ay);av.x=ab.max(av.x,au.x,ar.x,an.x);av.y=ab.max(av.y,au.y,ar.y,an.y);ax.push(&quot;padding:0 &quot;,n(av.x/d),&quot;px &quot;,n(av.y/d),&quot;px 0;filter:progid:DXImageTransform.Microsoft.Matrix(&quot;,Z.join(&quot;&quot;),&quot;, sizingmethod='clip');&quot;)}else{ax.push(&quot;top:&quot;,n(az.y/d),&quot;px;left:&quot;,n(az.x/d),&quot;px;&quot;)}ax.push(' &quot;&gt;','&lt;g_vml_:image src=&quot;',aq.src,'&quot;',' style=&quot;width:',d*al,&quot;px;&quot;,&quot; height:&quot;,d*ay,'px&quot;',' cropleft=&quot;',ao/ai,'&quot;',' croptop=&quot;',am/aw,'&quot;',' cropright=&quot;',(ai-ao-at)/ai,'&quot;',' cropbottom=&quot;',(aw-am-aA)/aw,'&quot;',&quot; /&gt;&quot;,&quot;&lt;/g_vml_:group&gt;&quot;);this.element_.insertAdjacentHTML(&quot;BeforeEnd&quot;,ax.join(&quot;&quot;))};q.stroke=function(ao){var Z=10;var ap=10;var ag=5000;var ai={x:null,y:null};var an={x:null,y:null};for(var aj=0;aj&lt;this.currentPath_.length;aj+=ag){var am=[];var ah=false;am.push(&quot;&lt;g_vml_:shape&quot;,' filled=&quot;',!!ao,'&quot;',' style=&quot;position:absolute;width:',Z,&quot;px;height:&quot;,ap,'px;&quot;',' coordorigin=&quot;0,0&quot;',' coordsize=&quot;',d*Z,&quot;,&quot;,d*ap,'&quot;',' stroked=&quot;',!ao,'&quot;',' path=&quot;');var aq=false;for(var ak=aj;ak&lt;Math.min(aj+ag,this.currentPath_.length);ak++){if(ak%ag==0&amp;&amp;ak&gt;0){am.push(&quot; m &quot;,n(this.currentPath_[ak-1].x),&quot;,&quot;,n(this.currentPath_[ak-1].y))}var m=this.currentPath_[ak];var al;switch(m.type){case&quot;moveTo&quot;:al=m;am.push(&quot; m &quot;,n(m.x),&quot;,&quot;,n(m.y));break;case&quot;lineTo&quot;:am.push(&quot; l &quot;,n(m.x),&quot;,&quot;,n(m.y));break;case&quot;close&quot;:am.push(&quot; x &quot;);m=null;break;case&quot;bezierCurveTo&quot;:am.push(&quot; c &quot;,n(m.cp1x),&quot;,&quot;,n(m.cp1y),&quot;,&quot;,n(m.cp2x),&quot;,&quot;,n(m.cp2y),&quot;,&quot;,n(m.x),&quot;,&quot;,n(m.y));break;case&quot;at&quot;:case&quot;wa&quot;:am.push(&quot; &quot;,m.type,&quot; &quot;,n(m.x-this.arcScaleX_*m.radius),&quot;,&quot;,n(m.y-this.arcScaleY_*m.radius),&quot; &quot;,n(m.x+this.arcScaleX_*m.radius),&quot;,&quot;,n(m.y+this.arcScaleY_*m.radius),&quot; &quot;,n(m.xStart),&quot;,&quot;,n(m.yStart),&quot; &quot;,n(m.xEnd),&quot;,&quot;,n(m.yEnd));break}if(m){if(ai.x==null||m.x&lt;ai.x){ai.x=m.x}if(an.x==null||m.x&gt;an.x){an.x=m.x}if(ai.y==null||m.y&lt;ai.y){ai.y=m.y}if(an.y==null||m.y&gt;an.y){an.y=m.y}}}am.push(' &quot;&gt;');if(!ao){w(this,am)}else{G(this,am,ai,an)}am.push(&quot;&lt;/g_vml_:shape&gt;&quot;);this.element_.insertAdjacentHTML(&quot;beforeEnd&quot;,am.join(&quot;&quot;))}};function w(m,ag){var j=F(m.strokeStyle);var p=j.color;var Z=j.alpha*m.globalAlpha;var i=m.lineScale_*m.lineWidth;if(i&lt;1){Z*=i}ag.push(&quot;&lt;g_vml_:stroke&quot;,' opacity=&quot;',Z,'&quot;',' joinstyle=&quot;',m.lineJoin,'&quot;',' miterlimit=&quot;',m.miterLimit,'&quot;',' endcap=&quot;',S(m.lineCap),'&quot;',' weight=&quot;',i,'px&quot;',' color=&quot;',p,'&quot; /&gt;')}function G(aq,ai,aK,ar){var aj=aq.fillStyle;var aB=aq.arcScaleX_;var aA=aq.arcScaleY_;var j=ar.x-aK.x;var p=ar.y-aK.y;if(aj instanceof U){var an=0;var aF={x:0,y:0};var ax=0;var am=1;if(aj.type_==&quot;gradient&quot;){var al=aj.x0_/aB;var m=aj.y0_/aA;var ak=aj.x1_/aB;var aM=aj.y1_/aA;var aJ=V(aq,al,m);var aI=V(aq,ak,aM);var ag=aI.x-aJ.x;var Z=aI.y-aJ.y;an=Math.atan2(ag,Z)*180/Math.PI;if(an&lt;0){an+=360}if(an&lt;0.000001){an=0}}else{var aJ=V(aq,aj.x0_,aj.y0_);aF={x:(aJ.x-aK.x)/j,y:(aJ.y-aK.y)/p};j/=aB*d;p/=aA*d;var aD=ab.max(j,p);ax=2*aj.r0_/aD;am=2*aj.r1_/aD-ax}var av=aj.colors_;av.sort(function(aN,i){return aN.offset-i.offset});var ap=av.length;var au=av[0].color;var at=av[ap-1].color;var az=av[0].alpha*aq.globalAlpha;var ay=av[ap-1].alpha*aq.globalAlpha;var aE=[];for(var aH=0;aH&lt;ap;aH++){var ao=av[aH];aE.push(ao.offset*am+ax+&quot; &quot;+ao.color)}ai.push('&lt;g_vml_:fill type=&quot;',aj.type_,'&quot;',' method=&quot;none&quot; focus=&quot;100%&quot;',' color=&quot;',au,'&quot;',' color2=&quot;',at,'&quot;',' colors=&quot;',aE.join(&quot;,&quot;),'&quot;',' opacity=&quot;',ay,'&quot;',' g_o_:opacity2=&quot;',az,'&quot;',' angle=&quot;',an,'&quot;',' focusposition=&quot;',aF.x,&quot;,&quot;,aF.y,'&quot; /&gt;')}else{if(aj instanceof T){if(j&amp;&amp;p){var ah=-aK.x;var aC=-aK.y;ai.push(&quot;&lt;g_vml_:fill&quot;,' position=&quot;',ah/j*aB*aB,&quot;,&quot;,aC/p*aA*aA,'&quot;',' type=&quot;tile&quot;',' src=&quot;',aj.src_,'&quot; /&gt;')}}else{var aL=F(aq.fillStyle);var aw=aL.color;var aG=aL.alpha*aq.globalAlpha;ai.push('&lt;g_vml_:fill color=&quot;',aw,'&quot; opacity=&quot;',aG,'&quot; /&gt;')}}}q.fill=function(){this.stroke(true)};q.closePath=function(){this.currentPath_.push({type:&quot;close&quot;})};function V(j,Z,p){var i=j.m_;return{x:d*(Z*i[0][0]+p*i[1][0]+i[2][0])-f,y:d*(Z*i[0][1]+p*i[1][1]+i[2][1])-f}}q.save=function(){var i={};v(this,i);this.aStack_.push(i);this.mStack_.push(this.m_);this.m_=J(B(),this.m_)};q.restore=function(){if(this.aStack_.length){v(this.aStack_.pop(),this);this.m_=this.mStack_.pop()}};function h(i){return isFinite(i[0][0])&amp;&amp;isFinite(i[0][1])&amp;&amp;isFinite(i[1][0])&amp;&amp;isFinite(i[1][1])&amp;&amp;isFinite(i[2][0])&amp;&amp;isFinite(i[2][1])}function aa(j,i,p){if(!h(i)){return}j.m_=i;if(p){var Z=i[0][0]*i[1][1]-i[0][1]*i[1][0];j.lineScale_=N(H(Z))}}q.translate=function(m,j){var i=[[1,0,0],[0,1,0],[m,j,1]];aa(this,J(i,this.m_),false)};q.rotate=function(j){var p=A(j);var m=l(j);var i=[[p,m,0],[-m,p,0],[0,0,1]];aa(this,J(i,this.m_),false)};q.scale=function(m,j){this.arcScaleX_*=m;this.arcScaleY_*=j;var i=[[m,0,0],[0,j,0],[0,0,1]];aa(this,J(i,this.m_),true)};q.transform=function(Z,p,ah,ag,j,i){var m=[[Z,p,0],[ah,ag,0],[j,i,1]];aa(this,J(m,this.m_),true)};q.setTransform=function(ag,Z,ai,ah,p,j){var i=[[ag,Z,0],[ai,ah,0],[p,j,1]];aa(this,i,true)};q.drawText_=function(am,ak,aj,ap,ai){var ao=this.m_,at=1000,j=0,ar=at,ah={x:0,y:0},ag=[];var i=u(E(this.font),this.element_);var p=ac(i);var au=this.element_.currentStyle;var Z=this.textAlign.toLowerCase();switch(Z){case&quot;left&quot;:case&quot;center&quot;:case&quot;right&quot;:break;case&quot;end&quot;:Z=au.direction==&quot;ltr&quot;?&quot;right&quot;:&quot;left&quot;;break;case&quot;start&quot;:Z=au.direction==&quot;rtl&quot;?&quot;right&quot;:&quot;left&quot;;break;default:Z=&quot;left&quot;}switch(this.textBaseline){case&quot;hanging&quot;:case&quot;top&quot;:ah.y=i.size/1.75;break;case&quot;middle&quot;:break;default:case null:case&quot;alphabetic&quot;:case&quot;ideographic&quot;:case&quot;bottom&quot;:ah.y=-i.size/2.25;break}switch(Z){case&quot;right&quot;:j=at;ar=0.05;break;case&quot;center&quot;:j=ar=at/2;break}var aq=V(this,ak+ah.x,aj+ah.y);ag.push('&lt;g_vml_:line from=&quot;',-j,' 0&quot; to=&quot;',ar,' 0.05&quot; ',' coordsize=&quot;100 100&quot; coordorigin=&quot;0 0&quot;',' filled=&quot;',!ai,'&quot; stroked=&quot;',!!ai,'&quot; style=&quot;position:absolute;width:1px;height:1px;&quot;&gt;');if(ai){w(this,ag)}else{G(this,ag,{x:-j,y:0},{x:ar,y:i.size})}var an=ao[0][0].toFixed(3)+&quot;,&quot;+ao[1][0].toFixed(3)+&quot;,&quot;+ao[0][1].toFixed(3)+&quot;,&quot;+ao[1][1].toFixed(3)+&quot;,0,0&quot;;var al=n(aq.x/d)+&quot;,&quot;+n(aq.y/d);ag.push('&lt;g_vml_:skew on=&quot;t&quot; matrix=&quot;',an,'&quot; ',' offset=&quot;',al,'&quot; origin=&quot;',j,' 0&quot; /&gt;','&lt;g_vml_:path textpathok=&quot;true&quot; /&gt;','&lt;g_vml_:textpath on=&quot;true&quot; string=&quot;',af(am),'&quot; style=&quot;v-text-align:',Z,&quot;;font:&quot;,af(p),'&quot; /&gt;&lt;/g_vml_:line&gt;');this.element_.insertAdjacentHTML(&quot;beforeEnd&quot;,ag.join(&quot;&quot;))};q.fillText=function(m,i,p,j){this.drawText_(m,i,p,j,false)};q.strokeText=function(m,i,p,j){this.drawText_(m,i,p,j,true)};q.measureText=function(m){if(!this.textMeasureEl_){var i='&lt;span style=&quot;position:absolute;top:-20000px;left:0;padding:0;margin:0;border:none;white-space:pre;&quot;&gt;&lt;/span&gt;';this.element_.insertAdjacentHTML(&quot;beforeEnd&quot;,i);this.textMeasureEl_=this.element_.lastChild}var j=this.element_.ownerDocument;this.textMeasureEl_.innerHTML=&quot;&quot;;this.textMeasureEl_.style.font=this.font;this.textMeasureEl_.appendChild(j.createTextNode(m));return{width:this.textMeasureEl_.offsetWidth}};q.clip=function(){};q.arcTo=function(){};q.createPattern=function(j,i){return new T(j,i)};function U(i){this.type_=i;this.x0_=0;this.y0_=0;this.r0_=0;this.x1_=0;this.y1_=0;this.r1_=0;this.colors_=[]}U.prototype.addColorStop=function(j,i){i=F(i);this.colors_.push({offset:j,color:i.color,alpha:i.alpha})};function T(j,i){Q(j);switch(i){case&quot;repeat&quot;:case null:case&quot;&quot;:this.repetition_=&quot;repeat&quot;;break;case&quot;repeat-x&quot;:case&quot;repeat-y&quot;:case&quot;no-repeat&quot;:this.repetition_=i;break;default:O(&quot;SYNTAX_ERR&quot;)}this.src_=j.src;this.width_=j.width;this.height_=j.height}function O(i){throw new P(i)}function Q(i){if(!i||i.nodeType!=1||i.tagName!=&quot;IMG&quot;){O(&quot;TYPE_MISMATCH_ERR&quot;)}if(i.readyState!=&quot;complete&quot;){O(&quot;INVALID_STATE_ERR&quot;)}}function P(i){this.code=this[i];this.message=i+&quot;: DOM Exception &quot;+this.code}var X=P.prototype=new Error;X.INDEX_SIZE_ERR=1;X.DOMSTRING_SIZE_ERR=2;X.HIERARCHY_REQUEST_ERR=3;X.WRONG_DOCUMENT_ERR=4;X.INVALID_CHARACTER_ERR=5;X.NO_DATA_ALLOWED_ERR=6;X.NO_MODIFICATION_ALLOWED_ERR=7;X.NOT_FOUND_ERR=8;X.NOT_SUPPORTED_ERR=9;X.INUSE_ATTRIBUTE_ERR=10;X.INVALID_STATE_ERR=11;X.SYNTAX_ERR=12;X.INVALID_MODIFICATION_ERR=13;X.NAMESPACE_ERR=14;X.INVALID_ACCESS_ERR=15;X.VALIDATION_ERR=16;X.TYPE_MISMATCH_ERR=17;G_vmlCanvasManager=e;CanvasRenderingContext2D=D;CanvasGradient=U;CanvasPattern=T;DOMException=P})()};</div></pre></div>
          </td>
        </tr>
      </table>
  </div>

          </div>
        </div>
      </div>
    </div>
</div>

<div class="frame frame-loading large-loading-area" style="display:none;">
  <img src="https://a248.e.akamai.net/assets.github.com/images/spinners/octocat-spinner-128.gif?1347543528" height="64" width="64">
</div>

        </div>
      </div>
      <div class="context-overlay"></div>
    </div>

      <div id="footer-push"></div><!-- hack for sticky footer -->
    </div><!-- end of wrapper - hack for sticky footer -->

      <!-- footer -->
      <div id="footer" >
        
  <div class="upper_footer">
     <div class="container clearfix">

       <h4 id="blacktocat">GitHub Links</h4>

       <ul class="footer_nav">
         <h4>GitHub</h4>
         <li><a href="https://github.com/about">About</a></li>
         <li><a href="https://github.com/blog">Blog</a></li>
         <li><a href="https://github.com/features">Features</a></li>
         <li><a href="https://github.com/contact">Contact &amp; Support</a></li>
         <li><a href="http://training.github.com/">Training</a></li>
         <li><a href="http://enterprise.github.com/">GitHub Enterprise</a></li>
         <li><a href="http://status.github.com/">Site Status</a></li>
       </ul>

       <ul class="footer_nav">
         <h4>Clients</h4>
         <li><a href="http://mac.github.com/">GitHub for Mac</a></li>
         <li><a href="http://windows.github.com/">GitHub for Windows</a></li>
         <li><a href="http://eclipse.github.com/">GitHub for Eclipse</a></li>
         <li><a href="http://mobile.github.com/">GitHub Mobile Apps</a></li>
       </ul>

       <ul class="footer_nav">
         <h4>Tools</h4>
         <li><a href="http://get.gaug.es/">Gauges: Web analytics</a></li>
         <li><a href="http://speakerdeck.com">Speaker Deck: Presentations</a></li>
         <li><a href="https://gist.github.com">Gist: Code snippets</a></li>

         <h4 class="second">Extras</h4>
         <li><a href="http://jobs.github.com/">Job Board</a></li>
         <li><a href="http://shop.github.com/">GitHub Shop</a></li>
         <li><a href="http://octodex.github.com/">The Octodex</a></li>
       </ul>

       <ul class="footer_nav">
         <h4>Documentation</h4>
         <li><a href="http://help.github.com/">GitHub Help</a></li>
         <li><a href="http://developer.github.com/">Developer API</a></li>
         <li><a href="http://github.github.com/github-flavored-markdown/">GitHub Flavored Markdown</a></li>
         <li><a href="http://pages.github.com/">GitHub Pages</a></li>
       </ul>

     </div><!-- /.site -->
  </div><!-- /.upper_footer -->

<div class="lower_footer">
  <div class="container clearfix">
    <div id="legal">
      <ul>
          <li><a href="https://github.com/site/terms">Terms of Service</a></li>
          <li><a href="https://github.com/site/privacy">Privacy</a></li>
          <li><a href="https://github.com/security">Security</a></li>
      </ul>

      <p>&copy; 2012 <span title="0.05017s from fe1.rs.github.com">GitHub</span> Inc. All rights reserved.</p>
    </div><!-- /#legal or /#legal_ie-->

  </div><!-- /.site -->
</div><!-- /.lower_footer -->


      </div><!-- /#footer -->

    

<div id="keyboard_shortcuts_pane" class="instapaper_ignore readability-extra" style="display:none">
  <h2>Keyboard Shortcuts <small><a href="#" class="js-see-all-keyboard-shortcuts">(see all)</a></small></h2>

  <div class="columns threecols">
    <div class="column first">
      <h3>Site wide shortcuts</h3>
      <dl class="keyboard-mappings">
        <dt>s</dt>
        <dd>Focus command bar</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>?</dt>
        <dd>Bring up this help dialog</dd>
      </dl>
    </div><!-- /.column.first -->

    <div class="column middle" style='display:none'>
      <h3>Commit list</h3>
      <dl class="keyboard-mappings">
        <dt>j</dt>
        <dd>Move selection down</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>k</dt>
        <dd>Move selection up</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>c <em>or</em> o <em>or</em> enter</dt>
        <dd>Open commit</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>y</dt>
        <dd>Expand URL to its canonical form</dd>
      </dl>
    </div><!-- /.column.first -->

    <div class="column last js-hidden-pane" style='display:none'>
      <h3>Pull request list</h3>
      <dl class="keyboard-mappings">
        <dt>j</dt>
        <dd>Move selection down</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>k</dt>
        <dd>Move selection up</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt>o <em>or</em> enter</dt>
        <dd>Open issue</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt><span class="platform-mac">⌘</span><span class="platform-other">ctrl</span> <em>+</em> enter</dt>
        <dd>Submit comment</dd>
      </dl>
      <dl class="keyboard-mappings">
        <dt><span class="platform-mac">⌘</span><span class="platform-other">ctrl</span> <em>+</em> shift p</dt>
        <dd>Preview comment</dd>
      </dl>
    </div><!-- /.columns.last -->

  </div><!-- /.columns.equacols -->

  <div class="js-hidden-pane" style='display:none'>
    <div class="rule"></div>

    <h3>Issues</h3>

    <div class="columns threecols">
      <div class="column first">
        <dl class="keyboard-mappings">
          <dt>j</dt>
          <dd>Move selection down</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>k</dt>
          <dd>Move selection up</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>x</dt>
          <dd>Toggle selection</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>o <em>or</em> enter</dt>
          <dd>Open issue</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt><span class="platform-mac">⌘</span><span class="platform-other">ctrl</span> <em>+</em> enter</dt>
          <dd>Submit comment</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt><span class="platform-mac">⌘</span><span class="platform-other">ctrl</span> <em>+</em> shift p</dt>
          <dd>Preview comment</dd>
        </dl>
      </div><!-- /.column.first -->
      <div class="column last">
        <dl class="keyboard-mappings">
          <dt>c</dt>
          <dd>Create issue</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>l</dt>
          <dd>Create label</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>i</dt>
          <dd>Back to inbox</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>u</dt>
          <dd>Back to issues</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>/</dt>
          <dd>Focus issues search</dd>
        </dl>
      </div>
    </div>
  </div>

  <div class="js-hidden-pane" style='display:none'>
    <div class="rule"></div>

    <h3>Issues Dashboard</h3>

    <div class="columns threecols">
      <div class="column first">
        <dl class="keyboard-mappings">
          <dt>j</dt>
          <dd>Move selection down</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>k</dt>
          <dd>Move selection up</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>o <em>or</em> enter</dt>
          <dd>Open issue</dd>
        </dl>
      </div><!-- /.column.first -->
    </div>
  </div>

  <div class="js-hidden-pane" style='display:none'>
    <div class="rule"></div>

    <h3>Network Graph</h3>
    <div class="columns equacols">
      <div class="column first">
        <dl class="keyboard-mappings">
          <dt><span class="badmono">←</span> <em>or</em> h</dt>
          <dd>Scroll left</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt><span class="badmono">→</span> <em>or</em> l</dt>
          <dd>Scroll right</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt><span class="badmono">↑</span> <em>or</em> k</dt>
          <dd>Scroll up</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt><span class="badmono">↓</span> <em>or</em> j</dt>
          <dd>Scroll down</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>t</dt>
          <dd>Toggle visibility of head labels</dd>
        </dl>
      </div><!-- /.column.first -->
      <div class="column last">
        <dl class="keyboard-mappings">
          <dt>shift <span class="badmono">←</span> <em>or</em> shift h</dt>
          <dd>Scroll all the way left</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>shift <span class="badmono">→</span> <em>or</em> shift l</dt>
          <dd>Scroll all the way right</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>shift <span class="badmono">↑</span> <em>or</em> shift k</dt>
          <dd>Scroll all the way up</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>shift <span class="badmono">↓</span> <em>or</em> shift j</dt>
          <dd>Scroll all the way down</dd>
        </dl>
      </div><!-- /.column.last -->
    </div>
  </div>

  <div class="js-hidden-pane" >
    <div class="rule"></div>
    <div class="columns threecols">
      <div class="column first js-hidden-pane" >
        <h3>Source Code Browsing</h3>
        <dl class="keyboard-mappings">
          <dt>t</dt>
          <dd>Activates the file finder</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>l</dt>
          <dd>Jump to line</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>w</dt>
          <dd>Switch branch/tag</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>y</dt>
          <dd>Expand URL to its canonical form</dd>
        </dl>
      </div>
    </div>
  </div>

  <div class="js-hidden-pane" style='display:none'>
    <div class="rule"></div>
    <div class="columns threecols">
      <div class="column first">
        <h3>Browsing Commits</h3>
        <dl class="keyboard-mappings">
          <dt><span class="platform-mac">⌘</span><span class="platform-other">ctrl</span> <em>+</em> enter</dt>
          <dd>Submit comment</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>escape</dt>
          <dd>Close form</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>p</dt>
          <dd>Parent commit</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>o</dt>
          <dd>Other parent commit</dd>
        </dl>
      </div>
    </div>
  </div>

  <div class="js-hidden-pane" style='display:none'>
    <div class="rule"></div>
    <h3>Notifications</h3>

    <div class="columns threecols">
      <div class="column first">
        <dl class="keyboard-mappings">
          <dt>j</dt>
          <dd>Move selection down</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>k</dt>
          <dd>Move selection up</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>o <em>or</em> enter</dt>
          <dd>Open notification</dd>
        </dl>
      </div><!-- /.column.first -->

      <div class="column second">
        <dl class="keyboard-mappings">
          <dt>e <em>or</em> shift i <em>or</em> y</dt>
          <dd>Mark as read</dd>
        </dl>
        <dl class="keyboard-mappings">
          <dt>shift m</dt>
          <dd>Mute thread</dd>
        </dl>
      </div><!-- /.column.first -->
    </div>
  </div>

</div>

    <div id="markdown-help" class="instapaper_ignore readability-extra">
  <h2>Markdown Cheat Sheet</h2>

  <div class="cheatsheet-content">

  <div class="mod">
    <div class="col">
      <h3>Format Text</h3>
      <p>Headers</p>
      <pre>
# This is an &lt;h1&gt; tag
## This is an &lt;h2&gt; tag
###### This is an &lt;h6&gt; tag</pre>
     <p>Text styles</p>
     <pre>
*This text will be italic*
_This will also be italic_
**This text will be bold**
__This will also be bold__

*You **can** combine them*
</pre>
    </div>
    <div class="col">
      <h3>Lists</h3>
      <p>Unordered</p>
      <pre>
* Item 1
* Item 2
  * Item 2a
  * Item 2b</pre>
     <p>Ordered</p>
     <pre>
1. Item 1
2. Item 2
3. Item 3
   * Item 3a
   * Item 3b</pre>
    </div>
    <div class="col">
      <h3>Miscellaneous</h3>
      <p>Images</p>
      <pre>
![GitHub Logo](/images/logo.png)
Format: ![Alt Text](url)
</pre>
     <p>Links</p>
     <pre>
http://github.com - automatic!
[GitHub](http://github.com)</pre>
<p>Blockquotes</p>
     <pre>
As Kanye West said:

> We're living the future so
> the present is our past.
</pre>
    </div>
  </div>
  <div class="rule"></div>

  <h3>Code Examples in Markdown</h3>
  <div class="col">
      <p>Syntax highlighting with <a href="http://github.github.com/github-flavored-markdown/" title="GitHub Flavored Markdown" target="_blank">GFM</a></p>
      <pre>
```javascript
function fancyAlert(arg) {
  if(arg) {
    $.facebox({div:'#foo'})
  }
}
```</pre>
    </div>
    <div class="col">
      <p>Or, indent your code 4 spaces</p>
      <pre>
Here is a Python code example
without syntax highlighting:

    def foo:
      if not bar:
        return true</pre>
    </div>
    <div class="col">
      <p>Inline code for comments</p>
      <pre>
I think you should use an
`&lt;addr&gt;` element here instead.</pre>
    </div>
  </div>

  </div>
</div>


    <div id="ajax-error-message" class="flash flash-error">
      <span class="mini-icon mini-icon-exclamation"></span>
      Something went wrong with that request. Please try again.
      <a href="#" class="mini-icon mini-icon-remove-close ajax-error-dismiss"></a>
    </div>

    <div id="logo-popup">
      <h2>Looking for the GitHub logo?</h2>
      <ul>
        <li>
          <h4>GitHub Logo</h4>
          <a href="http://github-media-downloads.s3.amazonaws.com/GitHub_Logos.zip"><img alt="Github_logo" src="https://a248.e.akamai.net/assets.github.com/images/modules/about_page/github_logo.png?1338956357" /></a>
          <a href="http://github-media-downloads.s3.amazonaws.com/GitHub_Logos.zip" class="minibutton download">Download</a>
        </li>
        <li>
          <h4>The Octocat</h4>
          <a href="http://github-media-downloads.s3.amazonaws.com/Octocats.zip"><img alt="Octocat" src="https://a248.e.akamai.net/assets.github.com/images/modules/about_page/octocat.png?1338956357" /></a>
          <a href="http://github-media-downloads.s3.amazonaws.com/Octocats.zip" class="minibutton download">Download</a>
        </li>
      </ul>
    </div>

    
    
    <span id='server_response_time' data-time='0.05158' data-host='fe1'></span>
    
  </body>
</html>

