<?php
/*
Description: 	This code is meant to be called by a WordPress shortcode
				It makes a call to the database and displays the data in
				a Flot chart.
Author: 		@jphornor and @tarahornor
License: 		GPL3
*/

// Here's our function! 
function flot_example(){					

//	Delete these lines out or change the message. 
echo '<ul><li>Remember to edit the layout.css <a href="' . plugins_url( $path ) . '/flot-for-wp/flot/layout.css">layout.css file</a> in the plugin folder.</li>';
echo '<li>View the source of this page to see how the format of the data needs to look.</li>';
echo '<li>Check out the flot-example.php file for a great way to experiment.</li></ul>';

/* 	
	Now we generate our JavaScript and HTML onto the page.
	This isn't my favorite way to do it, but it gets the job done.
*/
	echo '	<div id="flot-container">'; //Customize the width and height for your WP install in layout.css 
	echo '  <script type="text/javascript" src="' . includes_url( $path ) . 'js/jquery/jquery.js"></script>
			<script type="text/javascript" src="' . plugins_url( $path ) . '/flot-for-wp/flot/jquery.flot.js"></script>
			<script type="text/javascript" src="' . plugins_url( $path ) . '/flot-for-wp/flot/jquery.flot.resize.js"></script>
			<script type="text/javascript" src="' . plugins_url( $path ) . '/flot-for-wp/flot/excanvas.min.js"></script>
		    <link href="' . plugins_url( $path ) . '/flot-for-wp/flot/layout.css" rel="stylesheet" type="text/css">
			<div id="placeholder" style="width:95%; height:85%; max-width:100%; margin:auto;"></div>
			';
	echo '
			<script type="text/javascript">

			 	jQuery(document).ready(function($){ 
				var d1 = [
					[1351753200000,31],[1351839600000,33],[1351926000000,43],
					[1352012400000,54],[1352098800000,65],[1352185200000,41],
					[1352271600000,43],[1352358000000,37],[1352444400000,50],
					[1352530800000,54],[1352617200000,52],[1352703600000,67],
					[1352790000000,75],[1352876400000,72],[1352962800000,75],
					[1353049200000,78],[1353135600000,81]
					];
				var d2 = [
					[1351753200000,37],[1351839600000,43],[1351926000000,24],
					[1352012400000,22],[1352098800000,47],[1352185200000,67],
					[1352271600000,31],[1352358000000,34],[1352444400000,56],
					[1352530800000,65],[1352617200000,59],[1352703600000,61],
					[1352790000000,72],[1352876400000,79],[1352962800000,71],
					[1353049200000,79],[1353135600000,83]
					];
			
				var placeholder = $("#placeholder");
		        var plot = $.plot(placeholder, 
				[
					{	
						data: d1,
						label: "Time Series #1",
						lines: { 
									show: true, 
									fill: true, 
									fillColor: "rgba(141, 141, 141, .5)",
									lineWidth: 5,									
								}, 
						points: { 
									show: true,
									fill: true,
									fillColor: "#ccc",
									radius: 5,
								},										
					},
					{	
						data: d2,
						label: "Time Series #2",
						lines: { 
									show: true, 
									lineWidth: 5,									
								}, 
						points: { 
									show: true,
									fill: true,
									fillColor: "#ccc",
									radius: 5,
								},										
					}						
				], 
					{ 
						xaxis: ';
				echo		'{ mode: "time" },'; //Critical that this is NULL if not a time-based chart
				echo		'colors:
							["#f7941e", "#1db5cb"],
						grid:
							{
								backgroundColor: {colors: ["#ffffff","#c0c0c0"]},
								colors: ["#666"],
							},
						legend:
							{
								show: true,
								position: \'nw\',
								margin: 15,								
							},							
					}
					
				); 
			
					}	
				);
			
			</script></div>'; 		
	
}
// The shortcode in the Pushups Result post
add_shortcode( 'flot_example_sc', 'flot_example' );

?>